//Lsningsfrslag fr uppgift 3.9 frn uppgiftssamlingen fr
//Programmering av inbyggda system

#include "u39.h"

//Stter i den angivna biten till ett i var
#define setbit(var, bitnr) var = var | (1 << bitnr)
//Nollstller den angivna biten i var. Operatorn ~ r bitvis NOT
#define clearbit(var, bitnr) var = var & ~(1 << bitnr) 

//running = 1 medan lparen r mellan sensorerna
//running = 0 innan hen startar och efter hen gr i ml
int running;
//Vid varje avbrott som sker medan lparen r mellan
//sensorerna inkrementeras tick. 
volatile long int tick;
//Vi skuggar registren, eftersom vi inte vet om de 
//r lsbara. (Anta att de inte r det.)
port16 sensorshadow, clockshadow;
			
//Deklarera asm-rutiner som ska anropas frn C-koden
extern void sensortrap (void);
extern void clocktrap(void);
extern void cleari(void);

//Denna r given i uppgiften
void display(long int time) {
	//Skriver ut time till en display
	time; 
}


void initclock(void) {
	clockVector  = clocktrap;
	clockshadow  = 0;
	//Stt p avbrottsgenerering
	setbit(clockshadow,6);
	//Eftersom bit 7 = 0 kvitteras ven avbrott
	clockport = clockshadow;
}

void initsensor(void) {
	sensorVector = sensortrap;
	sensorshadow = 0;
	//Stt p sensorn
	setbit(sensorshadow, 0);
	//Stt p avbrottsgenerering
	setbit(sensorshadow, 6);
	//Eftersom bit 7 = 0 kvitteras ven avbrott
	sensorport = sensorshadow;
}

//Anropas av asm-avbrottsrutinen fr klockan
void clockinter (void) {
	tick++;	
	//Kvittera
	clearbit(clockshadow, 7);
	clockport = clockshadow;
}

//Anropas av asm-avbrottsrutinen fr sensorerna
void sensorinter (void) {
	//Om frsta avbrottet
	if (!running) {
		running = 1;
		//Starta klockan
		setbit(clockshadow, 0);
		clockport = clockshadow;
	} else { //Om andra avbrottet
		running = 0;
		//Stoppa klockan
		clearbit(clockshadow, 0);
		clockport = clockshadow;
	}
	//Kvittera avbrottet
	clearbit(sensorshadow, 7);
	sensorport = sensorshadow;
}

void init(void) {
	initclock();
	initsensor();
	running = 0;
	tick = 0;
	//Obs att i-flaggan stts till 0 efter att alla andra 
	//initieringar r klara
	cleari();
}


void main (void) {
	long int next = 5;
	//0L har typen long int. 0 har typen int. 
	display(0L);
	init();
	while (1) {
		//Det r 5 avbrott per hundradels sekund
		//s uppdatera endast displayen vart 5:e avbrott
		while (tick < next) ;
		display(tick/5);
		next += 5;
	}	
}
